with Ada.Unchecked_Deallocation;

package body Nodes is
   function Create_Node (Format : Format_Type) return Node_Type is
   begin
      return new Node_Record (Format);
   end Create_Node;

   procedure Free_Node (N : Node_Type)
   is
      procedure Deallocate is new Ada.Unchecked_Deallocation
        (Name => Node_Type, Object => Node_Record);
      C : Node_Type;
   begin
      C := N;
      Deallocate (C);
   end Free_Node;

   function Get_Nkind (N : Node_Type) return Kind_Type is
   begin
      return N.Kind;
   end Get_Nkind;

   procedure Set_Nkind (N : Node_Type; Kind : Kind_Type) is
   begin
      N.Kind := Kind;
   end Set_Nkind;

   procedure Set_Location (N : Node_Type; Location: Location_Type) is
   begin
      N.Location := Location;
   end Set_Location;

   function Get_Location (N: Node_Type) return Location_Type is
   begin
      return N.Location;
   end Get_Location;

   function Get_Back_End_Info (N : Node_Type) return System.Address is
   begin
      return N.Back_End_Info;
   end Get_Back_End_Info;

   procedure Set_Back_End_Info (N : Node_Type; Addr: System.Address) is
   begin
      N.Back_End_Info := Addr;
   end Set_Back_End_Info;

   function Get_Field1 (N : Node_Type) return Node_Type is
   begin
      return N.Field1;
   end Get_Field1;

   procedure Set_Field1 (N : Node_Type; V : Node_Type) is
   begin
      N.Field1 := V;
   end Set_Field1;

   function Get_Field2 (N : Node_Type) return Node_Type is
   begin
      return N.Field2;
   end Get_Field2;

   procedure Set_Field2 (N : Node_Type; V : Node_Type) is
   begin
      N.Field2 := V;
   end Set_Field2;

   function Get_Field3 (N : Node_Type) return Node_Type is
   begin
      return N.Field3;
   end Get_Field3;

   procedure Set_Field3 (N : Node_Type; V : Node_Type) is
   begin
      N.Field3 := V;
   end Set_Field3;

   function Get_Field4 (N : Node_Type) return Node_Type is
   begin
      return N.Field4;
   end Get_Field4;

   procedure Set_Field4 (N : Node_Type; V : Node_Type) is
   begin
      N.Field4 := V;
   end Set_Field4;

   function Get_Field5 (N : Node_Type) return Node_Type is
   begin
      return N.Field5;
   end Get_Field5;

   procedure Set_Field5 (N : Node_Type; V : Node_Type) is
   begin
      N.Field5 := V;
   end Set_Field5;

   function Get_Field6 (Node: Node_Type) return Node_Type is
   begin
      return Node.Field6;
   end Get_Field6;

   procedure Set_Field6 (Node: Node_Type; Val: Node_Type) is
   begin
      Node.Field6 := Val;
   end Set_Field6;

   function Get_Field7 (Node: Node_Type) return Node_Type is
   begin
      return Node.Field7;
   end Get_Field7;

   procedure Set_Field7 (Node: Node_Type; Val: Node_Type) is
   begin
      Node.Field7 := Val;
   end Set_Field7;

   function Get_Field8 (Node: Node_Type) return Node_Type is
   begin
      return Node.Field8;
   end Get_Field8;

   procedure Set_Field8 (Node: Node_Type; Val: Node_Type) is
   begin
      Node.Field8 := Val;
   end Set_Field8;

   function Get_Field9 (Node: Node_Type) return Node_Type is
   begin
      return Node.Field9;
   end Get_Field9;

   procedure Set_Field9 (Node: Node_Type; Val: Node_Type) is
   begin
      Node.Field9 := Val;
   end Set_Field9;

   function Get_Flag1 (N : Node_Type) return Boolean is
   begin
      return N.Flag1;
   end Get_Flag1;

   procedure Set_Flag1 (N : Node_Type; V : Boolean) is
   begin
      N.Flag1 := V;
   end Set_Flag1;

   function Get_Flag2 (N : Node_Type) return Boolean is
   begin
      return N.Flag2;
   end Get_Flag2;

   procedure Set_Flag2 (N : Node_Type; V : Boolean) is
   begin
      N.Flag2 := V;
   end Set_Flag2;

   function Get_Flag3 (N : Node_Type) return Boolean is
   begin
      return N.Flag3;
   end Get_Flag3;

   procedure Set_Flag3 (N : Node_Type; V : Boolean) is
   begin
      N.Flag3 := V;
   end Set_Flag3;

   function Get_Flag4 (N : Node_Type) return Boolean is
   begin
      return N.Flag4;
   end Get_Flag4;

   procedure Set_Flag4 (N : Node_Type; V : Boolean) is
   begin
      N.Flag4 := V;
   end Set_Flag4;

   function Get_Flag5 (N : Node_Type) return Boolean is
   begin
      return N.Flag5;
   end Get_Flag5;

   procedure Set_Flag5 (N : Node_Type; V : Boolean) is
   begin
      N.Flag5 := V;
   end Set_Flag5;


   function Get_Flag6 (N : Node_Type) return Boolean is
   begin
      return N.Flag6;
   end Get_Flag6;

   procedure Set_Flag6 (N : Node_Type; V : Boolean) is
   begin
      N.Flag6 := V;
   end Set_Flag6;

   function Get_State1 (N : Node_Type) return Bit2_Type is
   begin
      return N.State1;
   end Get_State1;

   procedure Set_State1 (N : Node_Type; V : Bit2_Type) is
   begin
      N.State1 := V;
   end Set_State1;

   function Get_State2 (N : Node_Type) return Bit2_Type is
   begin
      return N.State2;
   end Get_State2;

   procedure Set_State2 (N : Node_Type; V : Bit2_Type) is
   begin
      N.State2 := V;
   end Set_State2;

   function Get_State3 (N : Node_Type) return Bit2_Type is
   begin
      return N.State3;
   end Get_State3;

   procedure Set_State3 (N : Node_Type; V : Bit2_Type) is
   begin
      N.State3 := V;
   end Set_State3;

   function Get_Odigit1 (N : Node_Type) return Bit3_Type is
   begin
      return N.Odigit1;
   end Get_Odigit1;

   procedure Set_Odigit1 (N : Node_Type; V : Bit3_Type) is
   begin
      N.Odigit1 := V;
   end Set_Odigit1;


   function Get_Odigit2 (N : Node_Type) return Bit3_Type is
   begin
      return N.Odigit2;
   end Get_Odigit2;

   procedure Set_Odigit2 (N : Node_Type; V : Bit3_Type) is
   begin
      N.Odigit2 := V;
   end Set_Odigit2;


   function Get_Staticness1 (N : Node_Type) return Iir_Staticness is
   begin
      return N.Staticness1;
   end Get_Staticness1;

   procedure Set_Staticness1 (N : Node_Type; V : Iir_Staticness) is
   begin
      N.Staticness1 := V;
   end Set_Staticness1;


   function Get_State4 (N : Node_Type) return Bit2_Type is
   begin
      return N.State4;
   end Get_State4;

   procedure Set_State4 (N : Node_Type; V : Bit2_Type) is
   begin
      N.State4 := V;
   end Set_State4;


   function Get_Nbr1 (N : Node_Type) return Integer is
   begin
      return N.Nbr1;
   end Get_Nbr1;

   procedure Set_Nbr1 (N : Node_Type; V : Integer) is
   begin
      N.Nbr1 := V;
   end Set_Nbr1;


   function Get_Nbr2 (N : Node_Type) return Integer is
   begin
      return N.Nbr2;
   end Get_Nbr2;

   procedure Set_Nbr2 (N : Node_Type; V : Integer) is
   begin
      N.Nbr2 := V;
   end Set_Nbr2;


   function Get_Nbr3 (N : Node_Type) return Integer is
   begin
      return N.Nbr3;
   end Get_Nbr3;

   procedure Set_Nbr3 (N : Node_Type; V : Integer) is
   begin
      N.Nbr3 := V;
   end Set_Nbr3;


   function Get_Fp64 (N : Node_Type) return Iir_Fp64 is
   begin
      return N.Fp64;
   end Get_Fp64;

   procedure Set_Fp64 (N : Node_Type; V : Iir_Fp64) is
   begin
      N.Fp64 := V;
   end Set_Fp64;


   function Get_Int64 (N : Node_Type) return Iir_Int64 is
   begin
      return N.Int64;
   end Get_Int64;

   procedure Set_Int64 (N : Node_Type; V : Iir_Int64) is
   begin
      N.Int64 := V;
   end Set_Int64;

   procedure Set_Parent (N : Node_Type; V : Node_Type) is
   begin
      N.Parent := V;
   end Set_Parent;

   function Get_Parent (N : Node_Type) return Node_Type is
   begin
      return N.Parent;
   end Get_Parent;
end Nodes;
