with Name_Table;
with Tokens; use Tokens;

package body Std_Names is
   procedure Std_Names_Initialize is
      function GI (S : String) return Name_Id
         renames Name_Table.Get_Identifier;

--       function GI (S : String) return Name_Id is
--       begin
--          Ada.Text_IO.Put_Line ("add " & S);
--          return Name_Table.Get_Identifier (S);
--       end GI;

   begin
      Name_Table.Initialize;

      -- Create keywords.
      for I in Tok_Mod .. Tok_Protected loop
         if GI (Image (I)) /=
           Name_First_Keyword +
           Token_Type'Pos (I) - Token_Type'Pos (Tok_First_Keyword)
         then
            raise Program_Error;
         end if;
      end loop;

      -- Create operators.
      if GI ("=") /= Name_Op_Equality
        or else GI ("/=") /= Name_Op_Inequality
        or else GI ("<") /= Name_Op_Less
        or else GI ("<=") /= Name_Op_Less_Equal
        or else GI (">") /= Name_Op_Greater
        or else GI (">=") /= Name_Op_Greater_Equal
        or else GI ("+") /= Name_Op_Plus
        or else GI ("-") /= Name_Op_Minus
        or else GI ("*") /= Name_Op_Mul
        or else GI ("/") /= Name_Op_Div
        or else GI ("**") /= Name_Op_Exp
        or else GI ("&") /= Name_Op_Concatenation
      then
         raise Program_Error;
      end if;

      -- Create Attributes.
      if GI ("high") /= Name_High
        or else GI ("low") /= Name_Low
        or else GI ("length") /= Name_Length
        or else GI ("left") /= Name_Left
        or else GI ("right") /= Name_Right
        or else GI ("pos") /= Name_Pos
        or else GI ("val") /= Name_Val
        or else GI ("succ") /= Name_Succ
        or else GI ("pred") /= Name_Pred
        or else GI ("leftof") /= Name_Leftof
        or else GI ("rightof") /= Name_Rightof
        or else GI ("base") /= Name_Base
        or else GI ("ascending") /= Name_Ascending
        or else GI ("image") /= Name_Image
        or else GI ("value") /= Name_Value
        or else GI ("reverse_range") /= Name_Reverse_Range
        or else GI ("delayed") /= Name_Delayed
        or else GI ("stable") /= Name_Stable
        or else GI ("quiet") /= Name_Quiet
        or else GI ("transaction") /= Name_Transaction
        or else GI ("event") /= Name_Event
        or else GI ("active") /= Name_Active
        or else GI ("last_event") /= Name_Last_Event
        or else GI ("last_active") /= Name_Last_Active
        or else GI ("last_value") /= Name_Last_Value
        or else GI ("driving") /= Name_Driving
        or else GI ("driving_value") /= Name_Driving_Value
        or else GI ("behavior") /= Name_Behavior
        or else GI ("structure") /= Name_Structure
        or else GI ("simple_name") /= Name_Simple_Name
        or else GI ("instance_name") /= Name_Instance_Name
        or else GI ("path_name") /= Name_Path_Name
      then
         raise Program_Error;
      end if;

      --  Create standard.
      if GI ("std") /= Name_Std
        or else GI ("standard") /= Name_Standard
        or else GI ("boolean") /= Name_Boolean
        or else GI ("false") /= Name_False
        or else GI ("true") /= Name_True
        or else GI ("bit") /= Name_Bit
        or else GI ("character") /= Name_Character
        or else GI ("severity_level") /= Name_Severity_Level
        or else GI ("note") /= Name_Note
        or else GI ("warning") /= Name_Warning
        or else GI ("error") /= Name_Error
        or else GI ("failure") /= Name_Failure
        or else GI ("UNIVERSAL_INTEGER") /= Name_Universal_Integer
        or else GI ("UNIVERSAL_REAL") /= Name_Universal_Real
        or else GI ("integer") /= Name_Integer
        or else GI ("real") /= Name_Real
        or else GI ("time") /= Name_Time
        or else GI ("fs") /= Name_Fs
        or else GI ("ps") /= Name_Ps
        or else GI ("ns") /= Name_Ns
        or else GI ("us") /= Name_Us
        or else GI ("ms") /= Name_Ms
        or else GI ("sec") /= Name_Sec
        or else GI ("min") /= Name_Min
        or else GI ("hr") /= Name_Hr
        or else GI ("delay_length") /= Name_Delay_Length
        or else GI ("now") /= Name_Now
        or else GI ("natural") /= Name_Natural
        or else GI ("positive") /= Name_Positive
        or else GI ("string") /= Name_String
        or else GI ("bit_vector") /= Name_Bit_Vector
        or else GI ("file_open_kind") /= Name_File_Open_Kind
        or else GI ("read_mode") /= Name_Read_Mode
        or else GI ("write_mode") /= Name_Write_Mode
        or else GI ("append_mode") /= Name_Append_Mode
        or else GI ("file_open_status") /= Name_File_Open_Status
        or else GI ("open_ok") /= Name_Open_Ok
        or else GI ("status_error") /= Name_Status_Error
        or else GI ("name_error") /= Name_Name_Error
        or else GI ("mode_error") /= Name_Mode_Error
        or else GI ("foreign") /= Name_Foreign
      then
         raise Program_Error;
      end if;

      if GI ("nul") /= Name_Nul
        or else GI ("soh") /= Name_Soh
        or else GI ("stx") /= Name_Stx
        or else GI ("etx") /= Name_Etx
        or else GI ("eot") /= Name_Eot
        or else GI ("enq") /= Name_Enq
        or else GI ("ack") /= Name_Ack
        or else GI ("bel") /= Name_Bel
        or else GI ("bs") /= Name_Bs
        or else GI ("ht") /= Name_Ht
        or else GI ("lf") /= Name_Lf
        or else GI ("vt") /= Name_Vt
        or else GI ("ff") /= Name_Ff
        or else GI ("cr") /= Name_Cr
        or else GI ("so") /= Name_So
        or else GI ("si") /= Name_Si
        or else GI ("dle") /= Name_Dle
        or else GI ("dc1") /= Name_Dc1
        or else GI ("dc2") /= Name_Dc2
        or else GI ("dc3") /= Name_Dc3
        or else GI ("dc4") /= Name_Dc4
        or else GI ("nak") /= Name_Nak
        or else GI ("syn") /= Name_Syn
        or else GI ("etb") /= Name_Etb
        or else GI ("can") /= Name_Can
        or else GI ("em") /= Name_Em
        or else GI ("sub") /= Name_Sub
        or else GI ("esc") /= Name_Esc
        or else GI ("fsp") /= Name_Fsp
        or else GI ("gsp") /= Name_Gsp
        or else GI ("rsp") /= Name_Rsp
        or else GI ("usp") /= Name_Usp
        or else GI ("del") /= Name_Del
      then
         raise Program_Error;
      end if;

      if GI ("c128") /= Name_C128
        or else GI ("c129") /= Name_C129
        or else GI ("c130") /= Name_C130
        or else GI ("c131") /= Name_C131
        or else GI ("c132") /= Name_C132
        or else GI ("c133") /= Name_C133
        or else GI ("c134") /= Name_C134
        or else GI ("c135") /= Name_C135
        or else GI ("c136") /= Name_C136
        or else GI ("c137") /= Name_C137
        or else GI ("c138") /= Name_C138
        or else GI ("c139") /= Name_C139
        or else GI ("c140") /= Name_C140
        or else GI ("c141") /= Name_C141
        or else GI ("c142") /= Name_C142
        or else GI ("c143") /= Name_C143
        or else GI ("c144") /= Name_C144
        or else GI ("c145") /= Name_C145
        or else GI ("c146") /= Name_C146
        or else GI ("c147") /= Name_C147
        or else GI ("c148") /= Name_C148
        or else GI ("c149") /= Name_C149
        or else GI ("c150") /= Name_C150
        or else GI ("c151") /= Name_C151
        or else GI ("c152") /= Name_C152
        or else GI ("c153") /= Name_C153
        or else GI ("c154") /= Name_C154
        or else GI ("c155") /= Name_C155
        or else GI ("c156") /= Name_C156
        or else GI ("c157") /= Name_C157
        or else GI ("c158") /= Name_C158
        or else GI ("c159") /= Name_C159
      then
         raise Program_Error;
      end if;

      -- Create misc.
      if GI ("guard") /= Name_Guard
        or else GI ("deallocate") /= Name_Deallocate
        or else GI ("file_open") /= Name_File_Open
        or else GI ("file_close") /= Name_File_Close
        or else GI ("read") /= Name_Read
        or else GI ("write") /= Name_Write
        or else GI ("endfile") /= Name_Endfile
        or else GI ("p") /= Name_P
        or else GI ("f") /= Name_F
        or else GI ("external_name") /= Name_External_Name
        or else GI ("open_kind") /= Name_Open_Kind
        or else GI ("status") /= Name_Status
        or else GI ("first") /= Name_First
        or else GI ("last") /= Name_Last
        or else GI ("textio") /= Name_Textio
        or else GI ("work") /= Name_Work
        or else GI ("text") /= Name_Text
      then
         raise Program_Error;
      end if;
   end Std_Names_Initialize;
end Std_Names;
